## spamassassin 4.0.2

=== masses/Makefile ===
CC=		gcc
CFLAGS=		-g -O2 -Wall 
LDFLAGS=	-lm

PGAPACK=	../build/pga
PGAPACKLIBDIR=  $(PGAPACK)/lib/linux    # linux
#PGAPACKLIBDIR=  $(PGAPACK)/lib/sun4     # solaris

# What rule scoreset are we using?
include config

# what rules directory are we reading rules from?
RULES=          ../rules

#### Should be no need to modify below this line

all: perceptron

perceptron: perceptron.o
	$(CC) -o perceptron perceptron.o $(LDFLAGS)

perceptron.o: tmp/rules_${SCORESET}.pl tmp/tests.h tmp/scores.h
	$(CC) $(CFLAGS) -c -o perceptron.o perceptron.c

garescorer: tmp/rules_${SCORESET}.pl tmp/tests.h tmp/scores.h garescorer.c
	(cd ../build/pga/source; make)
	$(CC) $(CFLAGS) -DWL=2 -DOPTIMIZE -L $(PGAPACKLIBDIR) \
          -I $(PGAPACK)/include garescorer.c -o garescorer -lpgaO $(LDFLAGS)

tmp/rules_${SCORESET}.pl: tmp/.created ../build/parse-rules-for-masses
	perl ../build/parse-rules-for-masses -d $(RULES) -s $(SCORESET) \
            -o tmp/rules_${SCORESET}.pl

tmp/tests.h: tmp/.created tmp/ranges.data logs-to-c
	perl logs-to-c --cffile=$(RULES) --scoreset=$(SCORESET)

tmp/scores.h: tmp/tests.h

tmp/ranges.data: tmp/.created freqs score-ranges-from-freqs
	perl score-ranges-from-freqs $(RULES) $(SCORESET) < freqs

freqs: spam.log ham.log
	perl hit-frequencies -c $(RULES) -x -p -s $(SCORESET) > freqs

badrules: freqs
	perl lint-rules-from-freqs < freqs > badrules

tmp/.created:
	-mkdir tmp
	touch tmp/.created

clean:
	rm -rf *.o perceptron tmp freqs badrules \
          perceptron.scores garescorer garescorer.scores \
          ../build/pga/lib/linux/*

=== masses/evolve_metarule/Makefile ===
CFLAGS=-g -O2 -Wall
LDFLAGS=-lgaul -lgaul_util -lm

all: evolve_metarule hits.dat rules.dat

hits.dat rules.dat: preproc.pl ../../rules/*.cf ../ham.log ../spam.log
	perl preproc.pl ../ham.log ../spam.log

evolve_metarule: evolve_metarule.o
	${CC} ${LDFLAGS} -o $@ $^

clean:
	rm -f *.o evolve_metarule hits.dat rules.dat

=== debian/changelog ===
spamassassin (4.0.2-2) unstable; urgency=medium

  * Import patch improve-CNAME-caching.patch from upstream
  * import patch limit-CNAME-cache-to-10-entries-by-default-and-make-it
    (Closes: #1118009)
  * import patch skip-CNAME-checks-if-dns_max_cname_cache-==-0
  * import upstream patch uri_list-test-requires-network-access
  * Import upstream fix for improper handling of non-CNAME DNS records
    (Closes: 1117982)
  * disable dns lookups in the test suite during build
  * Add libtest-perl-critic-perl and libtest-pod-perl to build-deps for tests

 -- Noah Meyerhans <noahm@debian.org>  Mon, 13 Oct 2025 18:27:12 -0400

spamassassin (4.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Noah Meyerhans <noahm@debian.org>  Sun, 31 Aug 2025 11:03:05 -0400

=== debian/control ===
Source: spamassassin
Section: mail
Priority: optional
Maintainer: Noah Meyerhans <noahm@debian.org>
Build-Depends: debhelper-compat (= 13),
	       perl,
	       libssl-dev,
	       libhtml-parser-perl,
	       libnetaddr-ip-perl,
	       libnet-dns-perl <!nocheck>,
	       libberkeleydb-perl <!nocheck>,
	       netbase <!nocheck>,
	       libdbi-perl <!nocheck>,
	       libdbd-mysql-perl <!nocheck>,
	       libbsd-resource-perl <!nocheck>,
	       libio-string-perl <!nocheck>,
	       libnet-libidn2-perl <!nocheck>,
	       libtest-perl-critic-perl <!nocheck>,
	       libtest-pod-perl <!nocheck>,
	       libtext-diff-perl <!nocheck>
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://www.spamassassin.org/
Vcs-Git: https://salsa.debian.org/debian/spamassassin.git
Vcs-Browser: https://salsa.debian.org/debian/spamassassin

Package: spamassassin
Architecture: all
Multi-Arch: foreign
Depends: perl, libhtml-parser-perl, libsocket6-perl, adduser,
 libsys-hostname-long-perl, libarchive-tar-perl, libnet-dns-perl,
 libnetaddr-ip-perl, libhttp-date-perl, libmail-dkim-perl,
 libio-string-perl, libwww-perl | curl | w3m, ${misc:Depends}
Recommends: spamc, sa-compile (= ${source:Version}), libmail-spf-perl,
 libsys-syslog-perl, gnupg, libbsd-resource-perl, libmail-dmarc-perl
Suggests: razor, libio-socket-ssl-perl, libdbi-perl, pyzor,
 libcompress-zlib-perl, libencode-detect-perl,
 libgeoip2-perl, libnet-patricia-perl
Provides: libmail-spamassassin-perl
Description: Perl-based spam filter using text analysis
 SpamAssassin is a very powerful and fully configurable spam filter
 with numerous features including automatic white-listing, RBL
 testing, Bayesian analysis, header and body text analysis. It is
 designed to be called from a user's .procmail or .forward file, but
 can also be integrated into a Mail Transport Agent (MTA).
 .
 If you use spamassassin on a moderately high-volume mail server, you
 may which to consider installing the spamc and spamd packages, which
 provide a daemonized variant of spamassassin that avoids the need to
 start a full perl runtime for each message processed.

Package: spamc
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: spamd
Description: Client for SpamAssassin spam filtering daemon
 spamc is the client to communicate with spamd, the daemonized form of
 SpamAssassin (see the spamd package). It is written in C for
 maximum speed and minimum loading overhead.
 .
 spamc is quite useful for integrating spamassassin into an MTA or
 into a .procmailrc file because of its speed.
 .
 This package is useless unless you have spamassassin installed,
 either on this machine or another local machine (i.e. a mail server).

Package: sa-compile
Architecture: all
Multi-Arch: foreign
Enhances: spamassassin
Depends: spamassassin (= ${source:Version}), re2c, gcc, libc6-dev, make, ${misc:Depends}
Description: Tools for compiling SpamAssassin rules into C
 sa-compile uses "re2c" to compile the site-wide parts of the
 SpamAssassin ruleset into C code for more efficient processing by
 spamd or spamassassin.

Package: spamd
Architecture: all
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: spamassassin (= ${source:Version}),
	 init-system-helpers (>= 1.51),
	 ${shlibs:Depends}, ${misc:Depends}
Recommends: systemd | rsyslog | system-log-daemon
Replaces: spamassassin (<< 4.0.0~0.0svn1883440-2)
Breaks: spamassassin (<< 4.0.0~0.0svn1883440-2)
Description: Server for SpamAssassin spam filtering daemon
 spamd is a daemonized spamassassin process. Intended to be used with
 the spamc client, the persistent nature of the spamd server allows it
 to avoid the overhead of instantiating the perl for each processed
 message.

=== debian/rules ===
#!/usr/bin/make -f
#
# SpamAssassin debian/rules
# (C) 2004-2008 Duncan Findlay <duncf@debian.org>
# (C) 2008-2020 Noah Meyerhans <noahm@debian.org>
# (C) 2022 Andreas Metzler <ametzler@debian.org>
#
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to you under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

include /usr/share/dpkg/buildflags.mk

# The architecture-dependent portion of this package can be built separately
# (i.e. without building the rest).

SOURCE := $(shell dpkg-parsechangelog -SSource)
VERSION := $(shell dpkg-parsechangelog -SVersion)
VERSION_UPSTREAM := $(shell echo "$(VERSION)" | sed -e 's,-[^-]*$$,,')

DIR_ORIG = ../orig/$(SOURCE)-$(VERSION_UPSTREAM)
TAR_ORIG_NAME = $(SOURCE)_$(VERSION_UPSTREAM).orig.tar.xz
TAR_ORIG = $(firstword $(wildcard ../$(TAR_ORIG_NAME)) $(wildcard ../orig/$(TAR_ORIG_NAME)))

orig: $(DIR_ORIG)
	rsync --delete --exclude /debian --exclude .svk --exclude .svn --exclude .git --link-dest=$(DIR_ORIG)/ -a $(DIR_ORIG)/ .
	QUILT_PATCHES='$(CURDIR)/debian/patches' QUILT_PC=.pc quilt push --quiltrc - -a -q --fuzz=0

$(DIR_ORIG):
ifeq ($(TAR_ORIG),)
	$(error Cannot find orig tarball $(TAR_ORIG_NAME))
else
	mkdir -p ../orig
	tar -C ../orig -xaf $(TAR_ORIG)
endif


%:
	dh $@ --no-parallel

# For building both spamc and spamassassin
override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		LDFLAGS="$(LDFLAGS)" \
		DESTDIR=$(CURDIR)/debian/spamassassin \
		CONFDIR=/etc/spamassassin \
		ENABLE_SSL=yes

override_dh_auto_clean:
	dh_auto_clean --verbose
	[ ! -f Makefile ] || $(MAKE) veryclean

	rm -f rules/70_sandbox.cf rules/72_active.cf
	rm -f spamd/spamc.1p sa-awl.1p sa-check_spamd.1p
	rm -Rf t/log/* t/home
	rm -f debian/semantic.cache Mail-SpamAssassin-*.tar.gz

maintainerclean:
	dh_testdir
	rm -f build-indep-stamp build-arch-stamp configure-stamp
	rm -rf $(filter-out debian .svk .svn .git, $(wildcard * .[^.]*))


override_dh_auto_test:
	env CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		dh_auto_test --verbose --no-parallel -- HOME=$(CURDIR)/t/home \
		LDFLAGS="$(LDFLAGS)"

override_dh_auto_build-indep:
	dh_auto_build --verbose --no-parallel

	pod2man sa-awl.raw sa-awl.1p
	pod2man sa-check_spamd.raw sa-check_spamd.1p

override_dh_auto_build-arch:
	env CFLAGS="$(CPPFLAGS) $(CFLAGS)" \
		dh_auto_build --verbose --no-parallel -- \
		spamc/spamc

	-mkdir -p blib/man1
	pod2man spamc/spamc.pod blib/man1/spamc.1p

override_dh_installsystemd-indep:
	dh_installsystemd -pspamassassin --no-enable --no-start --name spamassassin-maintenance
	dh_installsystemd -Nspamassassin

# SpamAssassin and sa-compile:
override_dh_auto_install-indep:
	dh_auto_install --verbose --no-parallel \
		--destdir=$(CURDIR)/debian/spamassassin

	rm -f debian/spamassassin/usr/bin/spamc debian/spamassassin/usr/share/man/man1/spamc.1p
#	...and sa-compile
	rm -f debian/spamassassin/usr/bin/sa-compile debian/spamassassin/usr/share/man/man1/sa-compile.1p

#	Move spamd to /usr/sbin + fix the man file
	sed 's#SPAMD 1#SPAMD 8#' \
	 debian/spamassassin/usr/share/man/man1/spamd.1p \
	 > debian/spamd/usr/share/man/man8/spamd.8p
	rm -f debian/spamassassin/usr/share/man/man1/spamd.1p

	mv debian/spamassassin/usr/bin/spamd debian/spamd/usr/sbin/

#	These files are renamed upon installation, which dh_install
#	doesn't support, so we do it "the old fashioned way":
	install -m755 debian/spamassassin-maint.sh \
		debian/spamassassin/usr/sbin/spamassassin-maint

	install -m644 ldap/README \
		debian/spamd/usr/share/doc/spamd/README.ldap
	install -m644 spamd/README \
		debian/spamd/usr/share/doc/spamd/README.spamd

override_dh_install-indep:
	dh_install
	rm -f debian/spamassassin/usr/share/spamassassin/70_sandbox.cf \
		debian/spamassassin/usr/share/spamassassin/sandbox-*.pm \
		debian/spamassassin/usr/share/spamassassin/*.pre

#	 File modes are inconsistent in upstream's rules repositories. Set them to something sane:
	chmod 644 debian/spamassassin/usr/share/spamassassin/*.cf


# spamc (arch specific) rules follow
override_dh_auto_install-arch:
	install -m755 spamc/spamc debian/spamc/usr/bin/spamc
